#==============================================================================
# package      DE_EPAGES::ShoppingList::UI::JSON
# state        public
#----------------------------------------------------------------------------------------
# description  Common user interface to save and delete objects.
#========================================================================================
package DE_EPAGES::ShoppingList::UI::JSON;
use base DE_EPAGES::Presentation::UI::JSON;

use strict;
use DE_EPAGES::Database::API::Connection qw (GetCurrentDBHandle);

use JSON;

#==============================================================================
# Event handlers
#==============================================================================

sub JSONDeleteItemFromShoppingList {
    my $self = shift;
    my ($Servlet) = @_;
    my $Form = $Servlet->form;

    my $ShoppingList = $Servlet->object;
    my $ItemID       = $Form->value('ItemID');
    my $Shop         = $ShoppingList->getSite();

    my $ShoppingListEntry = $Shop->loadObject($ItemID, 'ShoppingListItem');

    $ShoppingListEntry->delete();

    return $self->writeContentOutput({'success' => JSON::true  });

}

sub JSONUpdateShoppingListItemQuantity {
    my $self = shift;
    my ($Servlet) = @_;
    my $Form = $Servlet->form;

    my $ShoppingList = $Servlet->object;
    my $ItemID       = $Form->value('ItemID');
    my $Quantity     = $Form->value('Quantity');
    my $Shop         = $ShoppingList->getSite();

    my $ShoppingListEntry = $Shop->loadObject($ItemID, 'ShoppingListItem');
    my $Product = $ShoppingListEntry->get('Product');

    if ( defined $Product) {
        $ShoppingListEntry->set({'Quantity' => $Quantity});
    } 

    #set shoppinglist change date
    $ShoppingList->set( { 'ChangeDate' => GetCurrentDBHandle()->currentDateTime() });

    return $self->writeContentOutput({'success' => JSON::true  });

}

1;
